ADDR_JOYSTICK_1=$DC01
ADDR_JOYSTICK_2=$DC00
JOYSTICK_FIRE_MASK=$EF
JOYSTICK_UP_DOWN_MASK     = $03
JOYSTICK_UP_MASK          = $01
JOYSTICK_DOWN_MASK        = $02
JOYSTICK_LEFT_RIGHT_MASK  = $0C
JOYSTICK_LEFT_MASK        = $04
JOYSTICK_RIGHT_MASK       = $08

   

; Bit 0 (peso 1) a cero si "up" esta activo.
; Bit 1 (peso 2) a cero si "down" esta activo
; Bit 2 (peso 4) a cero si "left" esta activo
; Bit 3 (peso 8) a cero si "right" esta activo
; Bit 4 (peso 16) a cero si "fire" esta activo
!macro readJoystick2 {
        
        LDA ADDR_JOYSTICK_2
}


checkJoy
        STA pres_a+1
        STX pres_x+1
        STY pres_y+1
        JSR doDebug
        ;LDA JOY_COUNTER
;        CMP #$30
;        BEQ doCheck
;        ADC #$01
;        STA JOY_COUNTER
;        JMP norepaint
        
        
doCheck
        
        ; handleJoystick onTop,onDown,onLeft,onRight,onFire
        LDA ADDR_JOYSTICK_2
        LDY #$00 ; Si al final, Y es mayor que 0, es que algo se ha pulsado y hay que repintar el mapa.        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;    Comprobacion top
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        CLC      ; Borramos el carry
        ROR      ; Rotamos a la derecha, con lo que el bit menos significativo pasa al carry.
        TAX      ; Preservamos la lectura del joystick ya rotada
        BCS checkDownMap ; Si el carry esta a 1, es que "arriba" no estaba pulsado.
        
        LDA PT_TILEOFFY   ; Cargamos el offset de tile en Y
        BNE @justdec      ; Si no es cero, solo hace falta decrementar.
        LDA PT_MAPTILEY
        BEQ @endTop       ; Si el tile Y es 0, y el offset era cero, estamos arriba del todo.No se hace nada.
        INY               ; Anotamos que ha habido movimiento.
        LDA #$03          ; Si era cero, pasamos al offset en Y 3
        STA PT_TILEOFFY   ; Guardamos ese offset        
        DEC PT_MAPTILEY   ; Y decrementamos el tile actual en Y.
        LDA PT_MAPOFFLO   ; Y en ese caso, hay que decrementar el offset absoluto de mapa
        SEC
        SBC #MAPWIDTH
        STA PT_MAPOFFLO
        BCS checkLeftMap
        DEC PT_MAPOFFHI
        JMP @endTop ; Se pasa a chequear derecha-izquierda.
@justdec
        DEC PT_TILEOFFY   ; Solo hay que decrementar el offset de tile. 
        INY               ; Anotamos que ha habido movimiento.
@endTop
        TXA
        ROR               ; ignoramos el bit de "down"
        TAX
        JMP checkLeftMap ; Se pasa a chequear derecha-izquierda.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;    Comprobacion down
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

checkDownMap       
        CLC        
        TXA
        ROR
        TAX        
        BCS checkLeftMap
        LDA PT_MAPTILEY
        CMP #35              
        BEQ checkLeftMap  ; Si estamos en MAPY=MAPHEIGHT-5, no hacemos nada
        INY
        LDA PT_TILEOFFY
        CMP #$03
        BNE @justinc        
        LDA #$00 ; New Tile 
        
        STA PT_TILEOFFY
        INC PT_MAPTILEY ; Incrementamos la Y del tile en el mapa.
        LDA PT_MAPOFFLO ; Y si incrementamos la Y de tile en el mapa, hay que incrementar el offset en el mapa.
        CLC
        ADC #MAPWIDTH
        STA PT_MAPOFFLO
        BCC checkLeftMap
        CLC
        INC PT_MAPOFFHI
        
        JMP checkLeftMap
@justinc
        INC PT_TILEOFFY

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;    Comprobacion left
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

checkLeftMap
        CLC
        TXA
        ROR
        TAX
        BCS checkRightMap        
        LDA PT_TILEOFFX
        BNE @justdec
        LDA PT_MAPTILEX
        BEQ @endLeft     ;Si el tileX ya era cero, no hacemos nada.
        INY ;Ha habido movimiento
        LDA #$03 ; Tile Height
        STA PT_TILEOFFX
        DEC PT_MAPTILEX ; Decrementamos la coordenada X en el mapa.Esto significa que tambien se decrementa el offset de memoria
        LDA PT_MAPOFFLO 
        BNE @justdec2     ; Si al cargar PT_MAPOFFLO no es cero, solo hay que decrementar la parte baja.
        DEC PT_MAPOFFLO   ; Pero si era cero, hay que decrementar la parte baja, y la alta.
        CLC
        DEC PT_MAPOFFHI        
        JMP @endLeft
@justdec2
        DEC PT_MAPOFFLO
        JMP @endLeft
@justdec
        DEC PT_TILEOFFX
        INY
@endLeft
        TXA
        ROR
        TAX
        JMP checkFireMap
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;    Comprobacion right
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

checkRightMap        
        CLC
        TXA
        ROR
        TAX
        BCS checkFireMap
        LDA PT_MAPTILEX
        CMP #30 ; 40-10     ; Si estamos todo a la derecha, no hacemos nada
        BEQ checkFireMap
        INY
        LDA PT_TILEOFFX
        CMP #$03
        BNE @justinc        
        LDA #$00 ; New Tile 
        STA PT_TILEOFFX
        INC PT_MAPTILEX ; Si hemos cambiado de coordenada X en el mapa, tenemos que modificar el offset global
        INC PT_MAPOFFLO        
        BNE checkFireMap ; Si al incrementar,no hemos llegado a cero (de FF a 00), saltamos
        INC PT_MAPOFFHI  ; Se incrementa la parte alta del mapa.
        JMP checkFireMap
@justinc
        INC PT_TILEOFFX
        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;    Comprobacion fire
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
checkFireMap

        CPY #$00  ; Se mira si ha habido algun tipo de movimiento.
        BEQ norepaint ; Si no lo ha habido, sale.
        ; Ha habido movimiento, establecemos una interrupcion para repintar el mapa
        lda #<repaintMap  ;this is how we set up
        sta $fffe  ;the address of our interrupt code
        lda #>repaintMap
        sta $ffff            
        +setRasterIntLineHiLo
        JMP done
norepaint
        lda #<checkJoy  ;this is how we set up
        sta $fffe  ;the address of our interrupt code
        lda #>checkJoy
        sta $ffff              
done
        LDA PT_MAPOFFLO
        STA PT_TEMP_MAPOFFLO
        LDA PT_MAPOFFHI
        STA PT_TEMP_MAPOFFHI
        
        +setRasterIntLine $30
        +setRasterIntLineHiLo
        +ackRasterInt
pres_a  LDA #$00
pres_x  LDX #$00
pres_y  LDY #$00
        RTI


