; Variables de configuracion.
!source "config.asm"
*=$2000

        jmp startup
; en A esta lo que se quiere mostrar

doDebug
        LDY #$00
        LDA PT_MAPTILEX
        jsr dbg
        LDA PT_TILEOFFX
        LDY #$03
        jsr dbg
        LDY #$06
        LDA PT_MAPTILEY
        jsr dbg
        LDA PT_TILEOFFY
        LDY #$09
        jsr dbg
        LDA JOY_COUNTER
        LDY #$0B
        jsr dbg
        rts


dbg       
  STY dbgreset + 1
  STX dbgreset + 3
  STA dbgreset + 5  
  PHA
  LSR
  LSR
  LSR
  LSR
  TAX
  LDA digits,X
  STA $0400,Y
  INY
  PLA
  AND #$0F
  TAX
  LDA digits,X
  STA $0400,Y
  LDA #$01
  STA $D800,Y
dbgreset
  LDY #$00
  LDX #$00
  LDA #$00
  RTS


!source "raster.asm"
!source "joystick.asm"
!source "Coloured2.asm"



startup
         +initProgram        
         

        lda #$35   ;we turn off the BASIC and KERNAL rom here
        sta $01    ;the cpu now sees RAM everywhere except at $d000-$e000, where still the registers of
                   ;SID/VICII/etc are visible        
        
        LDA $D018 ; Se prepara el puntero a 53272 para que apunte al nuevo juego de caracteres
        ORA #$0E  ; El juego de caracteres se encuentra en $3800, por lo que los 3 bits 
        STA $D018 ; Se almacena en 53272

;       Inicializacion del modo grafico
        LDA $D016
        ORA #$10
        STA $D016

        LDA #$00
        STA JOY_COUNTER

        ; color de fondo
        LDA #COLR_SCREEN
        STA $D021
        LDA #COLR_CHAR_MC1
        STA $D022
        LDA #COLR_CHAR_MC2
        STA $D023
        LDA #$0F
        STA JOY_COUNTER
        ; Se inicializa la posicion inicial de prueba.
        LDA #MAPTILEX
        STA PT_MAPTILEX
        LDA #MAPTILEY
        STA PT_MAPTILEY

        LDA #TILEOFFX
        STA PT_TILEOFFX
        LDA #TILEOFFY
        STA PT_TILEOFFY
        JSR initializeMapInScreen
;        JSR MAPPAINT
;        jmp *
        +enableRasterInterrupt
        lda #<checkJoy  ;this is how we set up
        sta $fffe  ;the address of our interrupt code
        lda #>checkJoy
        sta $ffff        
        +setRasterIntLine $30
        +setRasterIntLineHiLo

        cli        ;enable maskable interrupts again
        jmp *      ;we better don't RTS, the ROMS are now switched off, there's no way back to the system



repaintMap
        
        STA @pres_a+1
        STX @pres_x+1
        STY @pres_y+1
        LDA #$01 
        STA $D020
       ; JSR initializeMapInScreen
        LDA PT_MAPOFFLO
        STA PT_TEMP_MAPOFFLO
        LDA PT_MAPOFFHI ; Se mete ahora el puntero temporal, 
        STA PT_TEMP_MAPOFFHI
        
        jsr MAPPAINT
        LDA #$00 
        STA $D020        
        lda #<checkJoy  ;this is how we set up
        sta $fffe  ;the address of our interrupt code
        lda #>checkJoy
        sta $ffff        
        +setRasterIntLine $26
        +setRasterIntLineHiLo
        +ackRasterInt
        cli
        
@pres_a LDA #$00
@pres_x LDX #$00
@pres_y LDY #$00
        
        rti




digits 
!ct scr
!text "0123456789ABCDEF"